﻿using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace XAMLToPDF
{
    public partial class MainPage : ContentPage
    {
        public MainPage()
        {
            InitializeComponent();
        }
        public async void OnButtonClicked(object sender, EventArgs args)
        {
            MemoryStream stream = new MemoryStream();

            //Create a new PDF document
            using (PdfDocument document = new PdfDocument())
            {
                //Add page to the PDF document.
                PdfPage page = document.Pages.Add();

                //Create graphics instance.
                PdfGraphics graphics = page.Graphics;

                Stream imageStream = null;

                if (Device.OS == TargetPlatform.WinPhone || Device.OS == TargetPlatform.Windows)
                {
                    byte[] data = await DependencyService.Get<ISaveWindowsPhone>().CaptureAsync();
                    imageStream = new MemoryStream(data);
                }
                else
                {
                    imageStream = new MemoryStream(DependencyService.Get<ISave>().CaptureAsync().Result);
                }

                //Load the image
                PdfBitmap image = new PdfBitmap(imageStream);

                //Draw the image
                graphics.DrawImage(image, 0, 0, page.GetClientSize().Width, page.GetClientSize().Height);

                //Save the document into memory stream
                document.Save(stream);

            }

            stream.Position = 0;

            if (Device.OS == TargetPlatform.WinPhone || Device.OS == TargetPlatform.Windows)
                Xamarin.Forms.DependencyService.Get<ISaveWindowsPhone>().Save("XAMLtoPDF.pdf", "application/pdf", stream);
            else
                Xamarin.Forms.DependencyService.Get<ISave>().Save("XAMLtoPDF.pdf", "application/pdf", stream);
        }
    }
}
